// Standart includes
#include <unistd.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
// Threading
#include <pthread.h>
// XMMS stuff
#include <xmms/plugin.h>
#include <xmms/xmmsctrl.h>
#include <xmms/configfile.h>
// Sock stuff
#include <netinet/in.h>
#include <sys/types.h>
#include <sys/socket.h>
// GTK includes
#include <gtk/gtk.h>

#define CONFIGFILE "/.xmms/config"
#define LISTEN_ADDR INADDR_ANY

static GtkWidget *conf_dialog, *about_win;
static pthread_t main_thread;

// XMMS functions
void *cntrl_thread(void *args);
void cntrl_init(void);
void cntrl_cleanup(void);
void cntrl_conf(void);
void *main_routine(void *args);
//


// Inner functions
void print_headers(void);
void print_main(void);
void print_playlist(void);
void handle(void);
void parse(char *String);
void config_ok( GtkWidget *widget, gpointer data );
void confif_read(GtkWidget *wid, gpointer data);
// End

int	port;
char *request = 0;// = (char*)malloc(5000*sizeof(char));
char *tor = 0;// = (char*)malloc(400*sizeof(char));
char *script = 0;// = (char*)malloc(400*sizeof(char));
char *protocol = 0;
char *action = 0;// = (char*)malloc(100*sizeof(char));
char *value = 0;//= (char*)malloc(100*sizeof(char));
int sockt = -1;

char refresh[20];


GeneralPlugin cntrl_gp = 
{
	NULL,
	NULL,
	-1,
	"XMMS Control "VERSION,
	cntrl_init,
	NULL,
	cntrl_conf,
	cntrl_cleanup
};

GeneralPlugin *get_gplugin_info(void)
{
	return &cntrl_gp;
}

void cntrl_conf(void)
{
	GtkWidget *label,*table,*spin,*buttonbox, *ok_button, *cancel_button;
	GtkObject *adjustment;
	
	if (conf_dialog)
		return;
	conf_dialog = gtk_window_new(GTK_WINDOW_DIALOG);

	gtk_window_set_title(GTK_WINDOW(conf_dialog),"XMMS Control settings");
	gtk_window_set_position(GTK_WINDOW(conf_dialog), GTK_WIN_POS_MOUSE);
	gtk_signal_connect ( GTK_OBJECT(conf_dialog), "destroy", GTK_SIGNAL_FUNC(gtk_widget_destroy), &conf_dialog);
	
	table = gtk_table_new ( 3, 2, TRUE );
	gtk_container_add ( GTK_CONTAINER ( conf_dialog ), table );
	
	label = gtk_label_new ( "Port: " );
	gtk_table_attach_defaults ( GTK_TABLE ( table ), label, 0,1,0,1 );
	
	adjustment = gtk_adjustment_new( 4444, 1024, 65535, 1, 1000, 0 );
	
	spin = gtk_spin_button_new ( GTK_ADJUSTMENT ( adjustment ) , 0.5, 0 );
	
	gtk_table_attach_defaults ( GTK_TABLE ( table ), spin, 1,2,0,1 );
	
	buttonbox = gtk_hbutton_box_new ();
	gtk_button_box_set_layout ( GTK_BUTTON_BOX ( buttonbox ), GTK_BUTTONBOX_END );
	gtk_button_box_set_spacing ( GTK_BUTTON_BOX ( buttonbox ), 5 );
	gtk_table_attach_defaults ( GTK_TABLE ( table ), buttonbox, 0,2, 2,3 );
	
	ok_button = gtk_button_new_with_label ( "OK" );
	cancel_button = gtk_button_new_with_label ( "Cancel" );
	
	gtk_signal_connect ( GTK_OBJECT ( ok_button ), "clicked", GTK_SIGNAL_FUNC ( config_ok ), (gpointer) spin );
	gtk_signal_connect_object ( GTK_OBJECT ( cancel_button ), "clicked", GTK_SIGNAL_FUNC ( gtk_widget_destroy), (gpointer) conf_dialog );
	
	gtk_box_pack_start ( GTK_BOX ( buttonbox ), ok_button, TRUE, TRUE, 0 );
	gtk_box_pack_start ( GTK_BOX ( buttonbox ), cancel_button, TRUE, TRUE, 0 );
	
	gtk_widget_show_all ( conf_dialog );
}
	
void config_ok( GtkWidget *widget, gpointer data )
{
	gchar *configfile;
	ConfigFile *config;
	
	configfile = g_strconcat ( g_get_home_dir(), CONFIGFILE, NULL );
	
	if ( (config = xmms_cfg_open_file ( configfile )) == NULL )
		config = xmms_cfg_new();
	
	port = gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(data));
	
#ifdef DEBUG
	printf( "Value written: |%d|\n", port );
#endif
	
	xmms_cfg_write_int ( config, "XMMS Control", "port", port );
	xmms_cfg_write_file ( config, configfile );
	xmms_cfg_free ( config );

	gtk_widget_destroy ( conf_dialog );
	
	conf_dialog = NULL;
	g_free ( configfile );
	return;
}

void config_read ( GtkWidget *widget, gpointer data )
{
	gchar* configfile;
	ConfigFile *config;

	configfile = g_strconcat ( g_get_home_dir(), CONFIGFILE, NULL );
	if ( (config = xmms_cfg_open_file ( configfile )) != NULL )
	{
		xmms_cfg_read_int ( config, "XMMS Control", "port", &port );
	}
#ifdef DEBUG
	printf("Value of port: |%d|\n", port );
#endif
	g_free ( configfile );

}

void cntrl_init(void)
{
	config_read ( NULL, NULL );
	
	if ( pthread_create(&main_thread, NULL, main_routine, NULL) != 0 )
	{
		printf("Oh shit no creation\n");
	}
	return;
}

void cntrl_cleanup(void)
{
	pthread_cancel(main_thread);
	pthread_join(main_thread,0);
#ifdef DEBUG
	printf("We dieed!\n");
#endif
	//xmms_remote_stop(cntrl_gp.xmms_session);
}

void *main_routine(void *args)
{
	//xmms_remote_play(cntrl_gp.xmms_session);
	int sock = -1;
	//int BytesSent,BytesReceived;
	int len_inet;
	struct sockaddr_in local;
	struct sockaddr_in remote;

	sock = socket (AF_INET,SOCK_STREAM,0);
	local.sin_family = AF_INET;
	local.sin_port = htons(port);
	local.sin_addr.s_addr = INADDR_ANY;
#ifdef DEBUG
	printf("We're goind down\n");
#endif
	memset(&(local.sin_zero),0,8);
#ifdef DEBUG
	printf("Have we binded it?\n");
#endif
	if (bind(sock,(struct sockaddr*)&local,sizeof(local)) < 0)
	{
#ifdef DEBUG
		printf("Noooo :~\n");
#endif
		return(0);
	}
#ifdef DEBUG
	printf("We've binded it\n");
#endif
	if (listen(sock,1) < 0)
	{
		return(0);
	}
#ifdef DEBUG
	printf("We've listened it\n");
#endif
	while(1)
	{
		len_inet = sizeof(remote);
		sockt = accept(sock,(struct sockaddr*)&remote,&len_inet);
#ifdef DEBUG
		printf("We've accepted it!\n");
#endif
		handle();
	}
	return(0);
}

void print_headers(void)
{
	char *SString = malloc(480*sizeof(char));
	bzero(SString,480);
	strcpy(refresh,"10");
#ifdef DEBUG
	printf("Printing Headers\n");
#endif
	strcpy(SString,"HTTP/1.1 200 OK.\nrefresh: ");
	strcat(SString,refresh);
	strcat(SString,";URL = ");
	strcat(SString,script);
	strcat(SString,"\nContent-type: text/html\n\n");
	//write(sockt,SString,strlen(SString));
	send(sockt,SString,479,0);
#ifdef DEBUG
	printf("Printed Headers:|%s|\n",SString);
#endif
}

void handle(void)
{
	char QString[2048];

	//read(sockt,(char*)&QString,sizeof QString-1);
	recv(sockt,&QString,(sizeof(QString)-2),0);
	parse((char*)&QString);

	if(action != NULL)
	{
		if(strcmp(action,"action") == 0)
		{
			if (strcmp(value,"prev") == 0) xmms_remote_playlist_prev(cntrl_gp.xmms_session);
			if (strcmp(value,"next") == 0) xmms_remote_playlist_next(cntrl_gp.xmms_session);
			if (strcmp(value,"play") == 0) xmms_remote_play(cntrl_gp.xmms_session);
			if (strcmp(value,"stop") == 0) xmms_remote_stop(cntrl_gp.xmms_session);
			if (strcmp(value,"pause") == 0) xmms_remote_pause(cntrl_gp.xmms_session);
			if (strcmp(value,"shuffle") == 0) xmms_remote_toggle_shuffle(cntrl_gp.xmms_session);
			if (strcmp(value,"repeat") == 0) xmms_remote_toggle_repeat(cntrl_gp.xmms_session);
		}
		else if (strcmp(action,"playl") == 0)
		{
#ifdef DEBUG
			printf("Crash!\n");
#endif
			xmms_remote_set_playlist_pos(cntrl_gp.xmms_session,atoi(value));
#ifdef DEBUG
			printf("No crash!\n");
#endif
		}
		else if (strcmp(action,"del") == 0)
		{
#ifdef DEBUG
			printf("Craaaash!!!\n");
#endif
			xmms_remote_playlist_delete(cntrl_gp.xmms_session,atoi(value));
#ifdef DEBUG
			printf("Nooope!\n");
#endif
		}
	}
	if(strcmp(script,"/playlist.cgi") == 0)
	{
		print_playlist();
	}
	else print_main();

#ifdef DEBUG
	printf("Bang!~|%s|\n",QString);
#endif
	close(sockt);
#ifdef DEBUG
	printf("Closed sock\n");
#endif
}


void parse(char *String)
{
	request = (char*)malloc(strlen(String)*sizeof(char));
	bzero(request,strlen(String));
	request = strsep(&String,"\n");
	tor = (char*)malloc(strlen(String)*sizeof(char));
	script = (char*)malloc(strlen(String)*sizeof(char));
	action = (char*)malloc(strlen(String)*sizeof(char));
	value = (char*)malloc(strlen(String)*sizeof(char));
	protocol = (char*)malloc(strlen(String)*sizeof(char));
#ifdef DEBUG
	printf("Malloc crap\n");
#endif

	// Let's bzero the pointers
	bzero(tor,strlen(tor));
	bzero(action,strlen(action));
	bzero(script,strlen(script));
	bzero(value,strlen(value));
	bzero(protocol,strlen(protocol));
#ifdef DEBUG
	printf("bzeroing crap\n");
#endif

	tor = strsep(&request," ");
	if ( strstr(request,"?") == NULL )
	{
		script = strsep(&request," ");
		strcat(protocol,request);
	}
	else
	{
		script = strsep(&request,"?");
		action = strsep(&request,"=");
		if (strstr((const char*)&request,"&"))
			value = strsep(&request,"&");
		else
			value = strsep(&request," ");
		strcat(protocol,request);
	}
#ifdef DEBUG
	printf("String is: |%s|\n",String);
	printf("Request is: |%s|\n",request);
	printf("ToR is: |%s|\n",tor);
	printf("script is: |%s|\n",script);
	printf("action is: |%s|\n",action);
	printf("value is: |%s|\n",value);
	printf("protocol is: |%s|\n",protocol);
#endif
	
	
}

void print_main(void)
{
	char *SString = malloc(2048*sizeof(char));
	bzero(SString,2048);

	print_headers();

	strcat(SString,"<HTML><HEAD><TITLE>noway</TITLE>\n");
	strcat(SString,"<BODY text=\"blue\"><CENTER><p>Now Playing:<BR>\n ");
	strcat(SString,xmms_remote_get_playlist_title(cntrl_gp.xmms_session,xmms_remote_get_playlist_pos(cntrl_gp.xmms_session)));
	strcat(SString,"</p><a href=\"xmms.cgi?action=prev\">[ |&lt ]</a>&nbsp&nbsp<a href=\"xmms.cgi?action=play\">[ &gt ]</a>&nbsp&nbsp<a href=\"xmms.cgi?action=pause\">[ || ]</a>&nbsp&nbsp<a href=\"xmms.cgi?action=stop\">[ # ]</a>&nbsp&nbsp<a href=\"xmms.cgi?action=next\">[ &gt| ]</a>&nbsp&nbsp<p><a href=\"xmms.cgi?action=shuffle\">[ shuffle ]</a>&nbsp&nbsp&nbsp<a href=\"xmms.cgi?action=repeat\">[ repeat ]</a>&nbsp&nbsp<p>Links:<br><a href=\"playlist.cgi\">[ playlist ]</a></CENTER></BODY></HTML>\n");
	//write(sockt,SString,strlen(SString));
	send(sockt,SString,2048,0);
	close(sockt);
}

void print_playlist(void)
{
	int i;
	char* String = malloc(512*sizeof(char));
	bzero(String,512);
	
	print_headers();

	strcpy(String,"<HTML><HEAD><TITLE>Playlist</TITLE></HEAD><BODY text=blue><CENTER><A HREF=\"/xmms.cgi\">Main</A><TABLE width=\"80%%\">");
	send(sockt,String,512,0);
	bzero(String,512);

	for (i = 0; i < xmms_remote_get_playlist_length(cntrl_gp.xmms_session); i++)
	{
		sprintf(String,"<TR><TD width=\"80%%\">%d. %s</TD><TD width=\"10%%\"><A HREF=%s?playl=%d>[ play ]</A></TD><TD width=\"10%%\"><A HREF=%s?del=%d>[ del ]</TD></TR>",(i+1),xmms_remote_get_playlist_title(cntrl_gp.xmms_session,i),script,i,script,i);
		send(sockt,String,512,0);
		bzero(String,512);
	}
	strcpy(String,"</TABLE></CENTER></BODY></HTML>");
	send(sockt,String,512,0);
}
